var ParticleAssembler = require('../index');
var request = require('request');

var competitionId = 8, seasonId = 2016, fixtureId = 855179;

var api_uri = `http://003-optadata.eu-west-1.elasticbeanstalk.com/events/${competitionId}/${seasonId}/${fixtureId}`;
var api_uri_publishes = `http://003-optadata.eu-west-1.elasticbeanstalk.com/publishes/${competitionId}/${seasonId}/${fixtureId}`;
var socketio_uri = 'http://003-optawss.eu-west-1.elasticbeanstalk.com/opta-events';

var subscriber = new ParticleAssembler.EventSubscriber(api_uri, socketio_uri);
var publishSubscriber = new ParticleAssembler.EventSubscriber(api_uri_publishes, socketio_uri);
var cache = new ParticleAssembler.MemoryCache();

var checkpointSize = 10000;

var assembler = new ParticleAssembler.ParticleAssembler(
    subscriber,
    publishSubscriber,
    cache,
    {},
    checkpointSize
);

function checkCache(context, build_time) {
    console.error(subscriber.head + '/' + subscriber.remote_head);
    if (subscriber.caughtUp()) {
	console.error('Fetched all events');
	console.log('[');
	cache.hashes.forEach(function (hash, i, hashes) {
	    console.log(JSON.stringify(cache.data[hash], null, 4) + (i < hashes.length -1 ? ',' : ''));
	});
	console.log(']');
	console.error('Done.');
	process.exit(0);
    }
}

cache.on('update', checkCache);
cache.on('reset', checkCache);
