var R = require ( 'ramda' );

module.exports = R.curry ( function ( version, feeds ) {
    var findTeam = function ( team ) {
        return R.find ( function ( t ) {
            return team.id === t.id;
        } );
    };

    return {
        version: version,
        teams: R.fromPairs ( R.map ( function ( team ) {
            return [
                team.id,
                R.merge (
                    R.pick ( [ 'id', 'name', 'side', 'players', 'officials' ], R.merge (
                        team,
                        findTeam ( team )( R.path ( [ 'F9', 'competition', 'fixtures', 0, 'teams' ], feeds ) )
                    ) ),
                    R.pick ( [ 'name', 'short_club_name', 'symid' ], findTeam ( team )( R.path ( [ 'F40', 'competition', 'teams' ], feeds ) ) )
                )
            ];
        }, R.path ( [ 'F9', 'competition', 'teams' ], feeds ) ) ),
        sides: R.fromPairs ( R.map ( function ( team ) {
            return [ team.id, team.side ];
        }, R.path ( [ 'F9', 'competition', 'fixtures', 0, 'teams' ], feeds ) ) ),
        venue: R.path ( [ 'F9', 'competition', 'fixtures', 0, 'venue', 'name' ], feeds ),
        fixtureType: R.path ( [ 'F9', 'competition', 'fixtures', 0, 'type' ], feeds ),
        referee: [
            R.path ( [ 'F9', 'competition', 'fixtures', 0, 'officials', 0, 'name', 'first' ], feeds ),
            R.path ( [ 'F9', 'competition', 'fixtures', 0, 'officials', 0, 'name', 'last' ], feeds )
        ].join ( ' ' )
    };

} );
